VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------
'Title: DirectX Tutorial
'
'Description: This is your second DirectX8 application.
'             Unlike the previous one, this does it in
'             fullscreen. It took a little bit more code
'             to initialize this though, but hopefully
'             you should be able to understand it. Once it's
'             fullscreen, simply press Esc to end the program.
'
'Author: Jacob Roman
'
'Date: 12/01/2005
'
'Contact: jacob_c_roman@hotmail.com
'---------------------------------

Option Explicit

'Some color depth constants to help make the DX constants more readable.

Private Const COLOR_DEPTH_16_BIT As Long = D3DFMT_R5G6B5
Private Const COLOR_DEPTH_24_BIT As Long = D3DFMT_A8R8G8B8
Private Const COLOR_DEPTH_32_BIT As Long = D3DFMT_X8R8G8B8

Private DirectX8 As DirectX8 'The master DirectX object.
Private Direct3D As Direct3D8 'Controls all things 3D.
Private Direct3D_Device As Direct3DDevice8 'Represents the hardware rendering.

Private Running As Boolean 'Helps determine whether the main game loop is running.

Private Sub Form_Activate()

    Dim Display_Mode As D3DDISPLAYMODE 'Display mode desciption.
    Dim Direct3D_Window As D3DPRESENT_PARAMETERS 'Backbuffer and viewport description.

    frmMain.Caption = "DirectX Tutorial"
    
    Set DirectX8 = New DirectX8 'Creates the DirectX object.
    Set Direct3D = DirectX8.Direct3DCreate() 'Creates the Direct3D object using the DirectX object.
    
    'Now that we are working with fullscreen mode, we must set up the
    'screen resolution to switch to, rather than use the default screen
    'resolution.
    
    Display_Mode.Width = 800
    Display_Mode.Height = 600
    Display_Mode.Format = COLOR_DEPTH_16_BIT

    Direct3D_Window.Windowed = False 'The app will be in fullscreen mode.
    Direct3D_Window.SwapEffect = D3DSWAPEFFECT_COPY_VSYNC 'Refresh when the monitor does.
    Direct3D_Window.BackBufferCount = 1 '1 backbuffer only
    Direct3D_Window.BackBufferFormat = Display_Mode.Format 'Sets the format that was retrieved into the backbuffer.
    Direct3D_Window.BackBufferWidth = Display_Mode.Width 'Match the backbuffer width with the display width
    Direct3D_Window.BackBufferHeight = Display_Mode.Height 'Match the backbuffer height with the display height
    Direct3D_Window.hDeviceWindow = frmMain.hWnd 'Use frmMain as the device window.
    
    'Creates the rendering device with some useful info, along with the info
    'we've already setup for Direct3D_Window.
    Set Direct3D_Device = Direct3D.CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, frmMain.hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, Direct3D_Window)

    Running = True 'Initializations all set. It's now ok to activate the game loop.

    Do While Running = True
        
        DoEvents 'Allow events to happen so the program doesn't lock up.
        
        '----------------------------------------------------
        'DirectX automatically handles the framerate for you
        'which makes it run (at most) as fast as the monitors
        'refresh rate, so you don't need to add extra code to
        'slow down the loop and run at a certain number of frames
        'per second.
        '----------------------------------------------------
        
        'Clears the backbuffer.
        Direct3D_Device.Clear 0, ByVal 0, D3DCLEAR_TARGET, D3DColorRGBA(0, 0, 0, 0), 1#, 0
        
            'Rendering code goes here, but in this tutorial, it will be empty for now.
        
        'Flips the backbuffer into the form window.
        Direct3D_Device.Present ByVal 0, ByVal 0, 0, ByVal 0
        
    Loop

End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

    If KeyCode = vbKeyEscape Then 'If the user presses the Esc key...
    
        Running = False 'Helps the program bail out of the game loop.
        
        'Unload all of the DirectX objects
        
        Set Direct3D_Device = Nothing
        Set Direct3D = Nothing
        Set DirectX8 = Nothing
        
        Unload Me 'Unload the form
        
        End 'Ends the program
        
        'Although the Unload statement located above exits the program, you
        'will end up with an Automation error after doing so. The End statement
        'will help prevent that, and end the app completely.
    
    End If

End Sub

Private Sub Form_Unload(Cancel As Integer)

    Running = False 'Helps the program bail out of the game loop.
    
    'Unload all of the DirectX objects
    
    Set Direct3D_Device = Nothing
    Set Direct3D = Nothing
    Set DirectX8 = Nothing
    
    Unload Me 'Unload the form
    
    End 'Ends the program
    
    'Although the Unload statement located above exits the program, you
    'will end up with an Automation error after doing so. The End statement
    'will help prevent that, and end the app completely.

End Sub
